searchNodes=[{"doc":"Allows wrapping data to boxes.","ref":"Owl.Box.html","title":"Owl.Box","type":"module"},{"doc":"Wraps data into a box. Options are self-descriptive in definition of the type opt/0 , numbers mean number of symbols. Examples iex&gt; &quot;Owl&quot; |&gt; Owl.Box . new ( ) |&gt; to_string ( ) &quot;&quot;&quot; ┌───┐ │Owl│ └───┘ &quot;&quot;&quot; |&gt; String . trim_trailing ( ) iex&gt; &quot;Hello \\n world!&quot; ...&gt; |&gt; Owl.Box . new ( ...&gt; title : &quot;Greeting!&quot; , ...&gt; min_width : 20 , ...&gt; horizontal_align : :center , ...&gt; border_style : :double ...&gt; ) ...&gt; |&gt; to_string ( ) &quot;&quot;&quot; ╔═Greeting!══════════╗ ║ Hello ║ ║ world! ║ ╚════════════════════╝ &quot;&quot;&quot; |&gt; String . trim_trailing ( ) iex&gt; &quot;Success&quot; ...&gt; |&gt; Owl.Box . new ( ...&gt; min_width : 20 , ...&gt; min_height : 3 , ...&gt; border_style : :none , ...&gt; horizontal_align : :right , ...&gt; vertical_align : :bottom ...&gt; ) ...&gt; |&gt; to_string ( ) &quot;&quot;&quot; Success &quot;&quot;&quot; |&gt; String . trim_trailing ( ) iex&gt; &quot;OK&quot; ...&gt; |&gt; Owl.Box . new ( min_height : 5 , vertical_align : :middle ) ...&gt; |&gt; to_string ( ) &quot;&quot;&quot; ┌──┐ │ │ │ │ │OK│ │ │ │ │ └──┘ &quot;&quot;&quot; |&gt; String . trim_trailing ( ) iex&gt; &quot;VeryLongLine&quot; |&gt; Owl.Box . new ( max_width : 6 ) |&gt; to_string ( ) &quot;&quot;&quot; ┌────┐ │Very│ │Long│ │Line│ └────┘ &quot;&quot;&quot; |&gt; String . trim_trailing ( ) iex&gt; &quot;VeryLongLine&quot; |&gt; Owl.Box . new ( max_width : 4 , border_style : :none ) |&gt; to_string ( ) &quot;&quot;&quot; Very Long Line &quot;&quot;&quot; |&gt; String . trim_trailing ( ) iex&gt; &quot;Green!&quot; ...&gt; |&gt; Owl.Tag . new ( :green ) ...&gt; |&gt; Owl.Box . new ( title : Owl.Tag . new ( &quot;Red!&quot; , :red ) ) ...&gt; |&gt; Owl.Tag . new ( :cyan ) ...&gt; |&gt; Owl.Data . to_ansidata ( ) ...&gt; |&gt; to_string ( ) &quot;&quot;&quot; \e[36m┌─\e[31mRed!\e[36m\e[49m────┐\e[39m\e[49m \e[36m│\e[32mGreen!\e[36m\e[49m │\e[39m\e[49m \e[36m└─────────┘\e[39m\e[49m\e[0m &quot;&quot;&quot; |&gt; String . trim_trailing ( )","ref":"Owl.Box.html#new/2","title":"Owl.Box.new/2","type":"function"},{"doc":"","ref":"Owl.Box.html#t:opt/0","title":"Owl.Box.opt/0","type":"type"},{"doc":"A set of functions for iodata/0 with tags.","ref":"Owl.Data.html","title":"Owl.Data","type":"module"},{"doc":"Adds a prefix before each line of the data . An important feature is that styling of the data will be saved for each line. Example iex&gt; &quot;first \\n second&quot; |&gt; Owl.Tag . new ( :red ) |&gt; Owl.Data . add_prefix ( Owl.Tag . new ( &quot;test: &quot; , :yellow ) ) [ [ Owl.Tag . new ( &quot;test: &quot; , :yellow ) , Owl.Tag . new ( [ &quot;first&quot; ] , :red ) ] , &quot; \\n &quot; , [ Owl.Tag . new ( &quot;test: &quot; , :yellow ) , Owl.Tag . new ( [ &quot;second&quot; ] , :red ) ] ]","ref":"Owl.Data.html#add_prefix/2","title":"Owl.Data.add_prefix/2","type":"function"},{"doc":"Returns list of t() containing count elements each. Example iex&gt; Owl.Data . chunk_every ( ...&gt; [ &quot;first second &quot; , Owl.Tag . new ( [ &quot;third&quot; , Owl.Tag . new ( &quot; fourth&quot; , :blue ) ] , :red ) ] , ...&gt; 7 ...&gt; ) [ &quot;first s&quot; , [ &quot;econd &quot; , Owl.Tag . new ( [ &quot;t&quot; ] , :red ) ] , Owl.Tag . new ( [ &quot;hird&quot; , Owl.Tag . new ( [ &quot; fo&quot; ] , :blue ) ] , :red ) , Owl.Tag . new ( [ &quot;urth&quot; ] , :blue ) ]","ref":"Owl.Data.html#chunk_every/2","title":"Owl.Data.chunk_every/2","type":"function"},{"doc":"Returns length of the data. Examples iex&gt; Owl.Data . length ( [ &quot;222&quot; ] ) 3 iex&gt; Owl.Data . length ( [ 222 ] ) 1 iex&gt; Owl.Data . length ( [ [ [ ] ] ] ) 0 iex&gt; Owl.Data . length ( [ &quot;222&quot; , Owl.Tag . new ( [ &quot;333&quot; , &quot;444&quot; ] , :green ) ] ) 9","ref":"Owl.Data.html#length/1","title":"Owl.Data.length/1","type":"function"},{"doc":"Splits data by new lines. A special case of split/2 . Example iex&gt; Owl.Data . lines ( [ &quot;first \\n second \\n &quot; , Owl.Tag . new ( &quot;third \\n fourth&quot; , :red ) ] ) [ &quot;first&quot; , &quot;second&quot; , Owl.Tag . new ( [ &quot;third&quot; ] , :red ) , Owl.Tag . new ( [ &quot;fourth&quot; ] , :red ) ]","ref":"Owl.Data.html#lines/1","title":"Owl.Data.lines/1","type":"function"},{"doc":"Divides data into parts based on a pattern saving sequences for tagged data in new tags. Example iex&gt; Owl.Data . split ( [ &quot;first second &quot; , Owl.Tag . new ( &quot;third fourth&quot; , :red ) ] , &quot; &quot; ) [ &quot;first&quot; , &quot;second&quot; , Owl.Tag . new ( [ &quot;third&quot; ] , :red ) , Owl.Tag . new ( [ &quot;fourth&quot; ] , :red ) ]","ref":"Owl.Data.html#split/2","title":"Owl.Data.split/2","type":"function"},{"doc":"Transforms data to IO.ANSI.ansidata/0 format which can be consumed by IO module. Examples iex&gt; &quot;hello&quot; |&gt; Owl.Tag . new ( [ :red , :cyan_background ] ) |&gt; Owl.Data . to_ansidata ( ) [ [ [ [ [ [ [ ] | &quot;\e[46m&quot; ] | &quot;\e[31m&quot; ] , &quot;hello&quot; ] | &quot;\e[39m&quot; ] | &quot;\e[49m&quot; ] | &quot;\e[0m&quot; ]","ref":"Owl.Data.html#to_ansidata/1","title":"Owl.Data.to_ansidata/1","type":"function"},{"doc":"","ref":"Owl.Data.html#unlines/1","title":"Owl.Data.unlines/1","type":"function"},{"doc":"Zips corresponding lines into 1 line. The zipping finishes as soon as either data completes. Examples iex&gt; Owl.Data . zip ( &quot;a \\n b \\n c&quot; , &quot;d \\n e \\n f&quot; ) [ [ &quot;a&quot; , &quot;d&quot; ] , &quot; \\n &quot; , [ &quot;b&quot; , &quot;e&quot; ] , &quot; \\n &quot; , [ &quot;c&quot; , &quot;f&quot; ] ] iex&gt; Owl.Data . zip ( &quot;a \\n b&quot; , &quot;c&quot; ) [ [ &quot;a&quot; , &quot;c&quot; ] ] iex&gt; 1 .. 3 ...&gt; |&gt; Enum . map ( &amp; to_string / 1 ) ...&gt; |&gt; Enum . map ( &amp; Owl.Box . new / 1 ) |&gt; Enum . reduce ( &amp; Owl.Data . zip / 2 ) |&gt; to_string ( ) &quot;&quot;&quot; ┌─┐┌─┐┌─┐ │3││2││1│ └─┘└─┘└─┘ &quot;&quot;&quot; |&gt; String . trim_trailing ( )","ref":"Owl.Data.html#zip/2","title":"Owl.Data.zip/2","type":"function"},{"doc":"A recursive data type that is similar to iodata/0 , but additionally supports Owl.Tag.t/1 . Can be written to stdout using Owl.IO.puts/2 .","ref":"Owl.Data.html#t:t/0","title":"Owl.Data.t/0","type":"type"},{"doc":"A set of functions for handling IO with support of Owl.Data.t/0 .","ref":"Owl.IO.html","title":"Owl.IO","type":"module"},{"doc":"Returns a width of a terminal. A wrapper around :io.columns/0 , but returns nil if terminal is not found. This is useful for convinient falling back to other value using ||/2 operator. Example Owl.IO . columns ( ) || 80","ref":"Owl.IO.html#columns/0","title":"Owl.IO.columns/0","type":"function"},{"doc":"Asks user to type a confirmation. Valid inputs are y , Y , n , N and blank string. User will be asked to type a confirmation again on invalid input. Options :message - typically a question about performing operation. Defaults to &quot;Are you sure?&quot; . :default - a value that is used when user responds with a blank string. Defaults to false . Examples Owl.IO . confirm ( ) #=&gt; Are you sure? [yN] n false Owl.IO . confirm ( message : Owl.Tag . new ( &quot;Really?&quot; , :red ) , default : true ) #=&gt; Really? [Yn] true","ref":"Owl.IO.html#confirm/1","title":"Owl.IO.confirm/1","type":"function"},{"doc":"Reads a line from the stdio and casts a value to the given type. After reading a line from stdio it will be automatically trimmed with String.trim/2 . The end value will be returned when user types a valid value. Options :secret - set to true if you want to make input invisible. Defaults to false . :label - a text label. Defaults to nil (no label). :optional - a boolean that sets whether value is optional. Defaults to false . :cast - casts a value after reading it from stdio . Defaults to :string . Possible values: an anonymous function with arity 1 that is described by cast_input/0 a pair with built-in type represented as atom and a keyword-list with options. Built-in types: :integer , options: :min - a minimum allowed value. Defaults to nil (no lower bound). :max - a maximum allowed value. Defaults to nil (no upper bound). :string , options: no options an atom which is simply an alias to {atom(), []} Examples Owl.IO . input ( ) #=&gt; &gt; hello world &quot;hello world&quot; Owl.IO . input ( secret : true ) #=&gt; &gt; &quot;password&quot; Owl.IO . input ( optional : true ) #=&gt; &gt; nil Owl.IO . input ( label : &quot;Your age&quot; , cast : { :integer , min : 18 , max : 100 } ) #=&gt; Your age #=&gt; &gt; 12 #=&gt; must be greater than or equal to 18 #=&gt; Your age #=&gt; &gt; 102 #=&gt; must be less than or equal to 100 #=&gt; Your age #=&gt; &gt; 18 18 Owl.IO . input ( label : &quot;Birth date in ISO 8601 format:&quot; , cast : &amp; Date . from_iso8601 / 1 ) #=&gt; Birth date in ISO 8601 format: #=&gt; &gt; 1 January #=&gt; invalid_format #=&gt; Birth date in ISO 8601 format: #=&gt; &gt; 2021-01-01 ~D[2021-01-01]","ref":"Owl.IO.html#input/1","title":"Owl.IO.input/1","type":"function"},{"doc":"Select multiple values from the given nonempty list. Input item numbers must be separated by any non-digit character. Most likely you'd want to use spaces or commas. Options :label - a text label. Defaults to nil (no label). :render_as - a function that renders given item. Defaults to Function.identity/1 . :min - a minimum output list length. Defaults to nil (no lower bound). :max - a maximum output list length. Defaults to nil (no upper bound). Example Owl.IO . multiselect ( [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; ] , min : 2 , label : &quot;Select 2 numbers:&quot; , render_as : &amp; String . upcase / 1 ) #=&gt; 1. ONE #=&gt; 2. TWO #=&gt; 3. THREE #=&gt; #=&gt; Select 2 numbers: #=&gt; &gt; 1 #=&gt; the number of elements must be greater than or equal to 2 #=&gt; Select 2 numbers: #=&gt; &gt; 1 3 [ &quot;one&quot; , &quot;three&quot; ]","ref":"Owl.IO.html#multiselect/2","title":"Owl.IO.multiselect/2","type":"function"},{"doc":"Opens data in editor for editing. Returns updated data when file is saved and editor is closed. Similarly to IEx.Helpers.open/1 , this function uses ELIXIR_EDITOR environment variable. __FILE__ notation is supported as well. Example # use neovim in alacritty terminal emulator as an editor $ export ELIXIR_EDITOR = &quot;alacritty -e nvim&quot; # open editor from Elixir code Owl.IO . open_in_editor ( &quot;hello \\n world&quot; )","ref":"Owl.IO.html#open_in_editor/1","title":"Owl.IO.open_in_editor/1","type":"function"},{"doc":"Wrapper around IO.puts/2 that accepts Owl.Data.t/0 Example Owl.IO . puts ( [ &quot;Hello &quot; , Owl.Tag . new ( &quot;world&quot; , :green ) ] ) #=&gt; Hello world","ref":"Owl.IO.html#puts/2","title":"Owl.IO.puts/2","type":"function"},{"doc":"Selects one item from the given nonempty list. Returns value immediatelly if list contains only 1 element. Options :label - a text label. Defaults to nil (no label). :render_as - a function that renders given item. Defaults to Function.identity/1 . Examples Owl.IO . select ( [ &quot;one&quot; , &quot;two&quot; , &quot;three&quot; ] ) #=&gt; 1. one #=&gt; 2. two #=&gt; 3. three #=&gt; #=&gt; &gt; 1 &quot;one&quot; ~D[2001-01-01] |&gt; Date . range ( ~D[2001-01-03] ) |&gt; Enum . to_list ( ) |&gt; Owl.IO . select ( render_as : &amp; Date . to_iso8601 / 1 , label : &quot;Please select a date&quot; ) #=&gt; 1. 2001-01-01 #=&gt; 2. 2001-01-02 #=&gt; 3. 2001-01-03 #=&gt; #=&gt; Please select a date #=&gt; &gt; 2 ~D[2001-01-02] packages = [ %{ name : &quot;elixir&quot; , description : &quot;programming language&quot; } , %{ name : &quot;asdf&quot; , description : &quot;version manager&quot; } , %{ name : &quot;neovim&quot; , description : &quot;fork of vim&quot; } ] Owl.IO . select ( packages , render_as : fn %{ name : name , description : description } -&gt; [ Owl.Tag . new ( name , :cyan ) , &quot; \\n &quot; , Owl.Tag . new ( description , :light_black ) ] end ) #=&gt; 1. elixir #=&gt; programming language #=&gt; 2. asdf #=&gt; version manager #=&gt; 3. neovim #=&gt; fork of vim #=&gt; #=&gt; &gt; 3 %{ description : &quot;fork of vim&quot; , name : &quot;neovim&quot; }","ref":"Owl.IO.html#select/2","title":"Owl.IO.select/2","type":"function"},{"doc":"","ref":"Owl.IO.html#t:cast_input/0","title":"Owl.IO.cast_input/0","type":"type"},{"doc":"","ref":"Owl.IO.html#t:confirm_option/0","title":"Owl.IO.confirm_option/0","type":"type"},{"doc":"","ref":"Owl.IO.html#t:input_option/0","title":"Owl.IO.input_option/0","type":"type"},{"doc":"","ref":"Owl.IO.html#t:multiselect_option/0","title":"Owl.IO.multiselect_option/0","type":"type"},{"doc":"","ref":"Owl.IO.html#t:select_option/0","title":"Owl.IO.select_option/0","type":"type"},{"doc":"A server that handles live updates in terminal. It partially implements The Erlang I/O Protocol , so it is possible to use Owl.LiveScreen as an I/O-device in Logger.Backends.Console and functions like Owl.IO.puts/2 , IO.puts/2 . When used as I/O-device, then output is printed above dynamic blocks. Example require Logger Logger . configure_backend ( :console , device : Owl.LiveScreen ) Owl.LiveScreen . add_block ( :dependency , state : :init , render : fn :init -&gt; &quot;init...&quot; dependency -&gt; [ &quot;dependency: &quot; , Owl.Tag . new ( dependency , :yellow ) ] end ) Owl.LiveScreen . add_block ( :compiling , render : fn :init -&gt; &quot;init...&quot; filename -&gt; [ &quot;compiling: &quot; , Owl.Tag . new ( to_string ( filename ) , :cyan ) ] end ) [ &quot;ecto&quot; , &quot;phoenix&quot; , &quot;ex_doc&quot; , &quot;broadway&quot; ] |&gt; Enum . each ( fn dependency -&gt; Owl.LiveScreen . update ( :dependency , dependency ) 1 .. 5 |&gt; Enum . map ( &amp; &quot;filename \#{ &amp;1 } .ex&quot; ) |&gt; Enum . each ( fn filename -&gt; Owl.LiveScreen . update ( :compiling , filename ) Process . sleep ( 1000 ) Logger . debug ( &quot; \#{ filename } compiled for dependency \#{ dependency } &quot; ) end ) end )","ref":"Owl.LiveScreen.html","title":"Owl.LiveScreen","type":"module"},{"doc":"Adds a sticky block to the bottom of the screen that can be updated using update/3 . Options :render - a function that accepts state and returns a view of the block. Defaults to Function.identity/1 , which means that state has to have type Owl.Data.t/0 . :state - initial state of the block. Defaults to nil . Example Owl.LiveScreen . add_block ( :footer , state : &quot;starting...&quot; ) # which is equivalent to Owl.LiveScreen . add_block ( :footer , render : fn nil -&gt; &quot;starting...&quot; data -&gt; data end )","ref":"Owl.LiveScreen.html#add_block/3","title":"Owl.LiveScreen.add_block/3","type":"function"},{"doc":"Renders data in buffer and detaches blocks.","ref":"Owl.LiveScreen.html#flush/1","title":"Owl.LiveScreen.flush/1","type":"function"},{"doc":"Starts a server. Server is started automatically by :owl application as a named process. Options :name - used for name registration as described in the &quot;Name registration&quot; section in the documentation for GenServer . Defaults to Owl.LiveScreen :refresh_every - a period of refreshing a screen in milliseconds. Defaults to 100. :terminal_width - a width of terminal in symbols. Defaults to :auto , which gets value from Owl.IO.columns/0 . If terminal is now a available, then the server won't be started.","ref":"Owl.LiveScreen.html#start_link/1","title":"Owl.LiveScreen.start_link/1","type":"function"},{"doc":"Renders data in buffer and terminates a server.","ref":"Owl.LiveScreen.html#stop/1","title":"Owl.LiveScreen.stop/1","type":"function"},{"doc":"Updates a state of the block for using it in the next render iteration. Example Owl.LiveScreen . add_block ( :footer , &quot;starting...&quot; ) Process . sleep ( 1000 ) Owl.LiveScreen . update ( :footer , &quot;...almost done...&quot; ) Process . sleep ( 1000 ) Owl.LiveScreen . update ( :footer , &quot;done!!!&quot; )","ref":"Owl.LiveScreen.html#update/3","title":"Owl.LiveScreen.update/3","type":"function"},{"doc":"","ref":"Owl.LiveScreen.html#t:add_block_option/0","title":"Owl.LiveScreen.add_block_option/0","type":"type"},{"doc":"","ref":"Owl.LiveScreen.html#t:block_id/0","title":"Owl.LiveScreen.block_id/0","type":"type"},{"doc":"","ref":"Owl.LiveScreen.html#t:start_option/0","title":"Owl.LiveScreen.start_option/0","type":"type"},{"doc":"Poor man's color picker.","ref":"Owl.Palette.html","title":"Owl.Palette","type":"module"},{"doc":"Returns palette with codes from 0 to 255. Owl.Palette . codes ( ) |&gt; Owl.IO . puts ( ) Selected color can be used as follows # print &quot;test&quot; using foreground color with code 161 &quot;test&quot; |&gt; Owl.Tag . new ( IO.ANSI . color ( 161 ) ) |&gt; Owl.IO . puts # print &quot;test&quot; using background color with code 161 &quot;test&quot; |&gt; Owl.Tag . new ( IO.ANSI . color_background ( 161 ) ) |&gt; Owl.IO . puts","ref":"Owl.Palette.html#codes/0","title":"Owl.Palette.codes/0","type":"function"},{"doc":"Returns palette with named codes. Owl.Palette . named ( ) |&gt; Owl.IO . puts ( ) Selected color can be used as follows # print &quot;test&quot; using cyan foreground color &quot;test&quot; |&gt; Owl.Tag . new ( :cyan ) |&gt; Owl.IO . puts # print &quot;test&quot; using light_green foreground color &quot;test&quot; |&gt; Owl.Tag . new ( :light_green ) |&gt; Owl.IO . puts # print &quot;test&quot; using light_green background color &quot;test&quot; |&gt; Owl.Tag . new ( :light_green_background ) |&gt; Owl.IO . puts","ref":"Owl.Palette.html#named/0","title":"Owl.Palette.named/0","type":"function"},{"doc":"Returns palette with individual RGB values. Owl.Palette . rgb ( ) |&gt; Owl.IO . puts ( ) Selected color can be used as follows # print &quot;test&quot; using foreground color RGB(4, 3, 2) &quot;test&quot; |&gt; Owl.Tag . new ( IO.ANSI . color ( 4 , 3 , 2 ) ) |&gt; Owl.IO . puts # print &quot;test&quot; using background color RGB(4, 3, 2) &quot;test&quot; |&gt; Owl.Tag . new ( IO.ANSI . color_background ( 4 , 3 , 2 ) ) |&gt; Owl.IO . puts","ref":"Owl.Palette.html#rgb/0","title":"Owl.Palette.rgb/0","type":"function"},{"doc":"A live progress bar. Single bar Owl.ProgressBar . start ( id : :users , label : &quot;Creating users&quot; , total : 1000 ) Enum . each ( 1 .. 100 , fn _ -&gt; Process . sleep ( 10 ) Owl.ProgressBar . inc ( id : :users ) end ) # Wait a bit to give ProgressBar server a time to send last state update to LiveScreen Process . sleep ( 1 ) Owl.LiveScreen . flush ( ) Multiple bars 1 .. 10 |&gt; Enum . map ( fn index -&gt; Task . async ( fn -&gt; range = 1 .. Enum . random ( 100 .. 500 ) label = &quot;Demo Progress # \#{ index } &quot; Owl.ProgressBar . start ( id : { :demo , index } , label : label , total : range . last , timer : true , bar_width_ratio : 0.3 , filled_symbol : &quot;#&quot; , partial_symbols : [ ] ) Enum . each ( range , fn _ -&gt; Process . sleep ( Enum . random ( 10 .. 50 ) ) Owl.ProgressBar . inc ( id : { :demo , index } ) end ) end ) end ) |&gt; Task . await_many ( :infinity ) Owl.LiveScreen . flush ( )","ref":"Owl.ProgressBar.html","title":"Owl.ProgressBar","type":"module"},{"doc":"Increases current value by step . When current value becomes equal to total , then progress bar terminates. Options :id - an required identifier of the progress bar. :step - a value by which current value should be increased. Defaults to 1. Examples Owl.ProgressBar . inc ( id : &quot;Creating users&quot; ) Owl.ProgressBar . inc ( id : &quot;Creating users&quot; , step : 10 )","ref":"Owl.ProgressBar.html#inc/1","title":"Owl.ProgressBar.inc/1","type":"function"},{"doc":"Renders a progress bar that can be consumed by Owl.IO.puts/2 . Used as a callback for blocks in Owl.LiveScreen . Examples iex&gt; Owl.ProgressBar . render ( %{ ...&gt; label : &quot;Demo&quot; , ...&gt; total : 200 , ...&gt; current : 60 , ...&gt; bar_width_ratio : 0.7 , ...&gt; start_symbol : &quot;[&quot; , ...&gt; end_symbol : &quot;]&quot; , ...&gt; filled_symbol : &quot;#&quot; , ...&gt; partial_symbols : [ ] , ...&gt; empty_symbol : &quot;.&quot; , ...&gt; screen_width : 40 ...&gt; } ) |&gt; to_string ( ) &quot;Demo [########....................] 30%&quot; iex&gt; Owl.ProgressBar . render ( %{ ...&gt; label : &quot;Demo&quot; , ...&gt; total : 200 , ...&gt; current : 8 , ...&gt; bar_width_ratio : 0.4 , ...&gt; start_symbol : &quot;|&quot; , ...&gt; end_symbol : &quot;|&quot; , ...&gt; filled_symbol : &quot;█&quot; , ...&gt; partial_symbols : [ &quot;▏&quot; , &quot;▎&quot; , &quot;▍&quot; , &quot;▌&quot; , &quot;▋&quot; , &quot;▊&quot; , &quot;▉&quot; ] , ...&gt; empty_symbol : &quot; &quot; , ...&gt; screen_width : 40 , ...&gt; start_time : - 576460748012758993 , ...&gt; current_time : - 576460748012729828 ...&gt; } ) |&gt; to_string ( ) &quot;Demo 00:29.2 |▋ | 4%&quot; iex&gt; Owl.ProgressBar . render ( %{ ...&gt; label : &quot;Demo&quot; , ...&gt; total : 200 , ...&gt; current : 8 , ...&gt; bar_width_ratio : 0.7 , ...&gt; start_symbol : &quot;[&quot; , ...&gt; end_symbol : &quot;]&quot; , ...&gt; filled_symbol : Owl.Tag . new ( &quot;≡&quot; , :cyan ) , ...&gt; partial_symbols : [ Owl.Tag . new ( &quot;-&quot; , :green ) , Owl.Tag . new ( &quot;=&quot; , :blue ) ] , ...&gt; empty_symbol : &quot; &quot; , ...&gt; screen_width : 40 ...&gt; } ) |&gt; Owl.Data . to_ansidata ( ) |&gt; to_string &quot;Demo [\e[36m≡\e[39m\e[49m\e[32m-\e[39m\e[49m ] 4%\e[0m&quot;","ref":"Owl.ProgressBar.html#render/1","title":"Owl.ProgressBar.render/1","type":"function"},{"doc":"Starts a progress bar on Owl.LiveScreen . Options :id - an id of the progress bar. Required. :label - a label of the progress bar. Required. :total - a total value. Required. :current - a current value. Defaults to 0 . :bar_width_ratio - a bar width ratio. Defaults to 0.7. :timer - set to true to launch a timer. Defaults to false . :start_symbol - a symbol that is rendered at the beginning of the progress bar. Defaults to &quot;[&quot; . :end_symbol - a symbol that rendered at the end of the progress bar. Defaults to &quot;]&quot; . :filled_symbol - a symbol that use used when current value is big enough to fill the cell. Defaults to &quot;≡&quot; :partial_symbols - a list of symbols that are used when current value is too small to render filled_symbol . Defaults to [&quot;-&quot;, &quot;=&quot;] . :empty_symbol - an empty symbol. Defaults to &quot; &quot; . :screen_width - a width of output data. Defaults to width of the terminal or 80 symbols, if a terminal is not available.","ref":"Owl.ProgressBar.html#start/1","title":"Owl.ProgressBar.start/1","type":"function"},{"doc":"","ref":"Owl.ProgressBar.html#t:id/0","title":"Owl.ProgressBar.id/0","type":"type"},{"doc":"","ref":"Owl.ProgressBar.html#t:label/0","title":"Owl.ProgressBar.label/0","type":"type"},{"doc":"An alternative to some System functions.","ref":"Owl.System.html","title":"Owl.System","type":"module"},{"doc":"A wrapper around System.cmd/3 which additionally logs executed command and args . If URL is found in logged message, then password in it is masked with asterisks. Examples &gt; Owl.System . cmd ( &quot;echo&quot; , [ &quot;test&quot; ] ) # 10:25:34.252 [debug] $ echo test { &quot;test \\n &quot; , 0 } &gt; Owl.System . cmd ( &quot;psql&quot; , [ &quot;postgresql://postgres:postgres@127.0.0.1:5432&quot; , &quot;-tAc&quot; , &quot;SELECT 1;&quot; ] ) # 10:25:50.947 [debug] $ psql postgresql://postgres:********@127.0.0.1:5432 -tAc &#39;SELECT 1;&#39; { &quot;1 \\n &quot; , 0 }","ref":"Owl.System.html#cmd/3","title":"Owl.System.cmd/3","type":"function"},{"doc":"A tag struct. Tag is a container for data and ANSI sequences associated with it. It allows having local binding for styles in console, similar to tags in HTML. Let's say you have a string that should written to stdout in red color. This can be easily done by using a naive approach: substring = &quot;world&quot; IO . puts ( [ IO.ANSI . red ( ) , &quot;Hello \#{ substring } !!&quot; ] ) It works well for easy cases. If you want to make substring in another color you can try this: substring = [ IO.ANSI . green ( ) , &quot;world&quot; ] IO . puts ( [ IO.ANSI . red ( ) , &quot;Hello \#{ substring } !!&quot; ] ) but you'll notice, that the text after substring is green too. In order make &quot;!!&quot; part red again, you have to write color explicitly: IO . puts ( [ IO.ANSI . red ( ) , &quot;Hello \#{ substring } \#{ IO.ANSI . red ( ) } !!&quot; ] ) if substring changes background color, you have to return to the previous one too: substring = [ IO.ANSI . green ( ) , IO.ANSI . red_background ( ) &quot;world&quot; ] IO . puts ( [ IO.ANSI . red ( ) , &quot;Hello \#{ substring } \#{ [ IO.ANSI . red ( ) , IO.ANSI . default_background ( ) ] } !!&quot; ] ) Such code is very hard to maintain. This is how the issue can be addressed with Owl.Tag : substring = Owl.Tag . new ( &quot;world&quot; , :green ) Owl.IO . puts ( Owl.Tag . new ( [ &quot;Hello &quot; , substring , &quot;!!&quot; ] , :red ) ) substring = Owl.Tag . new ( &quot;world&quot; , [ :green , :red_background ] ) Owl.IO . puts ( Owl.Tag . new ( [ &quot;Hello &quot; , substring , &quot;!!&quot; ] , :red ) )","ref":"Owl.Tag.html","title":"Owl.Tag","type":"module"},{"doc":"Builds a tag. Examples iex&gt; Owl.Tag . new ( [ &quot;hello &quot; , Owl.Tag . new ( &quot;world&quot; , :green ) , &quot;!!!&quot; ] , :red ) |&gt; inspect ( ) ~s|#Owl.Tag[:red]&lt;[&quot;hello &quot;, #Owl.Tag[:green]&lt;&quot;world&quot;&gt;, &quot;!!!&quot;]&gt;| iex&gt; Owl.Tag . new ( &quot;hello world&quot; , [ :green , :red_background ] ) |&gt; inspect ( ) ~s|#Owl.Tag[:green, :red_background]&lt;&quot;hello world&quot;&gt;|","ref":"Owl.Tag.html#new/2","title":"Owl.Tag.new/2","type":"function"},{"doc":"ANSI escape sequence. An atom like :green , :red_background , :light_cyan , light_red_background . A binary like &quot;\e[38;5;33m&quot; (which is IO.ANSI.color(33) or IO.ANSI.color(0, 2, 5) ). Currently, only colors are supported. Read about all available values in doc for IO.ANSI or Owl.Palette .","ref":"Owl.Tag.html#t:sequence/0","title":"Owl.Tag.sequence/0","type":"type"},{"doc":"","ref":"Owl.Tag.html#t:t/1","title":"Owl.Tag.t/1","type":"type"},{"doc":", _ , { o , o } / ) ) -- - &quot;-&quot; -- Owl is a toolkit for writing command-line user interfaces in Elixir. It provides a convinient interface for colorizing text using tags input control with validations and casting to various data types select/multiselect controls, inspired by AUR package managers editing text in ELIXIR_EDITOR wrapping multiline colorized data into ASCII boxes printing palette colors progress bars, multiple bars at the same time are supported as well live-updating of multiline blocks working with virtual device which partially implements The Erlang I/O Protocol and doesn't conflict with live blocks.","ref":"readme.html","title":"README","type":"extras"},{"doc":"","ref":"readme.html#demo","title":"README - Demo","type":"extras"},{"doc":"The package can be installed by adding owl to your list of dependencies in mix.exs : def deps do [ { :owl , &quot;~&gt; 0.1.0&quot; } ] end Documentation can be found at https://hexdocs.pm/owl .","ref":"readme.html#installation","title":"README - Installation","type":"extras"}]